<%@ Page Language="C#" %>
<%@ import Namespace="System.Data" %>
<%@ import Namespace="System.Data.OleDb" %>
<script runat="server">

    void GetRecords_Click(Object Sender, EventArgs E)
    {
     String ConnectionString = "Provider=Microsoft.Jet.OleDb.4.0;Data Source="+ Server.MapPath("Northwind.mdb") + ";";
    
        //Name of the Query Object to Access
        String CommandText = "[Sales By Year]";
    
        OleDbConnection _Connection = new OleDbConnection(ConnectionString);
        OleDbCommand _Command = new OleDbCommand(CommandText, _Connection);
        OleDbParameter _BeginingDate = new OleDbParameter();
        OleDbParameter _EndingDate = new OleDbParameter();
    
        _Command.CommandType = CommandType.StoredProcedure;
    
        //Set the input parameters required by the Query Object.
        _Command.Parameters.Add("@BeginningDate", DbType.Date).Value = BeginingDateTextBox.Text;
        _Command.Parameters.Add("@EndingDate", DbType.Date).Value = EndingDateTextBox.Text;
    
        try
    	{
            _Connection.Open();
    
            DataGrid1.DataSource = _Command.ExecuteReader(CommandBehavior.CloseConnection);
            DataGrid1.DataBind();
    	}
        catch (Exception Err)
	{
            ErrLiteralControl.Text = Err.ToString();
    
        }
	finally
	{
	    _Connection.Close();
	}
    
    }

</script>
<html>
	<head>
		<title>Invoking Parameterized Query Objects in Microsoft Access</title>
	</head>
	<body style="FONT-FAMILY: arial">
		<form runat="server">
			<h2>Parameterized Query Objects in Microsoft Access
				<hr size="1" />
			</h2>
			<p>
				Beginning Date<asp:TextBox id="BeginingDateTextBox" runat="server"></asp:TextBox>
				&nbsp;Ending Date<asp:TextBox id="EndingDateTextBox" runat="server"></asp:TextBox>
			</p>
			<p>
				<asp:Button id="GetRecords" onclick="GetRecords_Click" runat="server" Text="Get Records"></asp:Button>
			</p>
			<p>
				<asp:datagrid id="DataGrid1" runat="server" CellSpacing="1" GridLines="None" CellPadding="3" BackColor="White" ForeColor="Black" EnableViewState="False">
					<HeaderStyle font-bold="True" forecolor="white" backcolor="#4A3C8C"></HeaderStyle>
					<ItemStyle backcolor="#DEDFDE"></ItemStyle>
				</asp:datagrid>
			</p>
			<p>
				<asp:Literal id="ErrLiteralControl" runat="server" EnableViewState="False"></asp:Literal>
			</p>
		</form>
	</body>
</html>
