<%@ Page Language="C#" ClassName="Recipe1205cs" %>
<%@ import Namespace="System.Data" %>
<%@ import Namespace="System.Data.SqlClient" %>
<script runat="server">

    void Page_Load(Object sender, EventArgs e)
    {
        //object vars
        SqlConnection  sqlConnection;
        SqlDataAdapter sqlDataAdapter;
        SqlCommand     sqlCommand;
        DataSet		   dataSet;
        DataTable      dataTable;
    
		if (IsPostBack)
		{
			try
			{
			sqlConnection = new SqlConnection( "Integrated Security=yes;Initial Catalog=Northwind;Data Source=(local)" );

				//pass the stored proc name and SqlConnection
				sqlCommand = new SqlCommand( "Select * From Customers", sqlConnection );
	            
				//instantiate SqlAdapter and DataSet
				sqlDataAdapter = new SqlDataAdapter( sqlCommand );
				dataSet = new DataSet();
	    
				//populate the DatSet
				sqlDataAdapter.Fill( dataSet, "Customers" );
    
				//create and populate a DataColumn to set the PrimaryKey
				DataColumn [] pkColumn = new DataColumn[1];
				pkColumn[0] = dataSet.Tables[0].Columns["CustomerID"];
				//set the primary key to the CustomerID column
				dataSet.Tables[0].PrimaryKey = pkColumn;

				//find a row based on the value entered in the textbox
				DataRow rowFound = dataSet.Tables[0].Rows.Find(customerIdTextBox.Text);
				
				if (rowFound == null)
				{
					//display message if we count find anything
					msgLabel.Text = "The Customer ID entered was not found.";
				}
				else
				{
					//display some info from the DataRow that we found...
					//use a StringBuilder to concatenate strings more efficient
					StringBuilder stringBuilder = new StringBuilder("Contact ");
					//append strings and data to build output
					stringBuilder.Append(rowFound["ContactName"].ToString());
					stringBuilder.Append(", ");
					stringBuilder.Append(rowFound["ContactTitle"].ToString());
					stringBuilder.Append(" at ");
					stringBuilder.Append(rowFound["CompanyName"].ToString());
					//output to label
					msgLabel.Text = stringBuilder.ToString();
				}
			}
			catch( Exception exception )
			{
				msgLabel.Text = exception.ToString();
			}
		}
    }

</script>
<html>
	<head>
		<title>Finding a Particular Row in a DataSet</title>
	</head>
	<body>
		<form id="Recipe1107" method="post" runat="server">
			<asp:label id="customerIdLabel" runat="server">Customer ID:</asp:label><asp:textbox id="customerIdTextBox" runat="server"></asp:textbox><asp:button id="findButton" runat="server" Text="Find"></asp:button><br>
			<asp:label id="msgLabel" runat="server" Height="111px" Width="327px" ForeColor="#0000C0"></asp:label></form>
	</body>
</html>
