<%@ Page language="c#" AutoEventWireup="false" %>
<script language="C#" runat="server">
protected System.Xml.XmlDocument xmlSource = new System.Xml.XmlDocument();


private void Page_Load(object sender, System.EventArgs e) {
    ResultsPanel.Visible=false;
}

private void LoadButton_Click(object sender, System.EventArgs e) 
{
    System.IO.Stream xmlDocStream = GetXmlDoc(XmlSourceTextBox.Text);
    if(xmlDocStream!=null) 
    {
    try 
    {
        xmlSource.Load(xmlDocStream);
        ResultText.Text=xmlSource.InnerXml;
    }
    catch(Exception exc) 
    {
        ResultText.Text="Could not resolve the XML document. Error:" + exc.ToString();
    }
    finally 
    {
        xmlDocStream.Close();
    }
    
    } 
    else 
    {
		ResultText.Text="Could not resolve the XML document.";
    }
}

public static System.IO.Stream GetXmlDoc(string xmlsource) {
    ///first determine if xml source is actual raw xml or if it is a url or file path
    System.IO.Stream stream=null;
    if(xmlsource.StartsWith("<?xml") || xmlsource.StartsWith("<schema") ) 
    {
		//raw xml
		stream = new System.IO.MemoryStream(System.Text.ASCIIEncoding.ASCII.GetBytes(xmlsource));
	} 
	else 
	{
		//lets try to load it up in a System.URI
		try 
		{
			System.Uri xmluri = new System.Uri(xmlsource);          
			if(xmluri.IsFile) 
			{
				//file
				stream = new System.IO.FileStream(xmlsource, System.IO.FileMode.Open);
			} 
			else 
			{
				//url
				System.Net.HttpWebRequest request =  (System.Net.HttpWebRequest) System.Net.WebRequest.Create(xmluri);
				System.Net.WebResponse response = request.GetResponse();      
				stream = response.GetResponseStream();
			}
		}
		catch(Exception e) 
		{
        //not a valid uri
		}
    }
    return stream;
}

private void TranslateButton_Click(object sender, System.EventArgs e) 
{
    if(xmlSource==null || xmlSource.InnerText=="") xmlSource.LoadXml(ResultText.Text);
    try 
    {
		ResultsLiteral.Text = Transform(xmlSource, XslUrlTextBox.Text, null, null);
		ResultsPanel.Visible=true;
    }
    catch(Exception transformError) 
    {
		ResultsLiteral.Text=transformError.ToString();
    }
}

public string Transform(System.Xml.XmlDocument docXml, string xslUrl, string[] xslParamNames, string[] xslParamValues) {
    System.Xml.Xsl.XslTransform xslTransform = new System.Xml.Xsl.XslTransform();
    System.IO.StringWriter sResult = new System.IO.StringWriter();        
    //DocumentNavigator navSource;

    //LOAD UP THE XSL DOCUMENT
    //load xsl to a xsltransform object
    try 
    {
		xslTransform.Load(xslUrl);
    } 
    catch( Exception exc) 
    {

    }

    //load up the xsl parameters, if any
    System.Xml.Xsl.XsltArgumentList xslArgs = new System.Xml.Xsl.XsltArgumentList();
    if (xslParamNames!=null)
    {
		int counter=0;
		foreach(string paramname in xslParamNames) 
		{
			xslArgs.AddParam(paramname, null, xslParamValues[counter]);
		}
    }

    //try to transform it
    try 
    {
		// call transform
		if (xslParamNames!=null)
		{
			xslTransform.Transform(docXml, xslArgs, sResult);
		} 
		else 
		{
			xslTransform.Transform(docXml, null, sResult);
		}
    } 
    catch( Exception exc) 
    {
    
    }
    return sResult.ToString();
} //Transform
</script>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" >
<HTML>
	<HEAD>
		<title>Transforming an XML Document Using XSLT</title>
	</HEAD>
	<body>
		<form id="Form1" method="post" runat="server">
		  		Test out the form:<br />
  			1. For the XML Source use:  &quot;http://www.w3schools.com/xsl/cdcatalog.xml&quot;<br />
    		2. Hit the &quot;Load Xml Document&quot; button<br />
    		3. For the XSLT Source use: &quot;http://www.w3schools.com/xsl/cdcatalog.xsl&quot;<br />
    		4. Hit the &quot;Transform&quot; button.<br />
    		5. The result of the Transform will be outputted to the bottom LiteralControl.<br />

			<asp:textbox id="XmlSourceTextBox" runat="server" Width="379px" Height="162px" TextMode="MultiLine"></asp:textbox><BR>
			<asp:button id="LoadButton" runat="server" Text="Load XML Document" OnClick="LoadButton_Click"></asp:button><BR>
			<asp:TextBox id="ResultText" runat="server" Width="379px" Height="194px" TextMode="MultiLine"></asp:TextBox><BR>
			<asp:Button id="TranslateButton" runat="server" Text="Translate" OnClick="TranslateButton_Click"></asp:Button><BR>
			<asp:TextBox id="XslUrlTextBox" runat="server" Height="25px" Width="379"></asp:TextBox><BR>
			<asp:Panel id="ResultsPanel" runat="server" Height="396px" Width="991px" BorderWidth="1px" BorderColor="Red">
				<asp:Literal id="ResultsLiteral" runat="server"></asp:Literal>
			</asp:Panel>
		</form>
	</body>
</HTML>
