<%@ Page Language="vb" %>
<script language="VB" runat="server">

Protected xmlSource As New System.Xml.XmlDocument()

Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs)
    'Put user code to initialize the page here
    ResultsPanel.Visible = False
End Sub

Private Sub LoadButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    Dim xmlDocStream As System.IO.Stream = GetXmlDoc(XmlSourceTextBox.Text)
    If Not (xmlDocStream Is Nothing) Then
		Try
			xmlSource.Load(xmlDocStream)
			ResultText.Text = xmlSource.InnerXml
		Catch exc As Exception
			ResultText.Text = "Could not resolve the XML document. Error:" + exc.ToString()
		Finally
			xmlDocStream.Close()
		End Try
    Else
    ResultText.Text = "Could not resolve the XML document."
    End If
End Sub

Public Shared Function GetXmlDoc(ByVal xmlsource As String) As System.IO.Stream
    '/first determine if xml source is actual raw xml or if it is a url or file path
    Dim stream As System.IO.Stream = Nothing
    If xmlsource.StartsWith("<?xml") Or xmlsource.StartsWith("<schema") Then
    'raw xml
    stream = New System.IO.MemoryStream(System.Text.ASCIIEncoding.ASCII.GetBytes(xmlsource))
    Else
		'lets try to load it up in a System.URI
		Try
			Dim xmluri As New System.Uri(xmlsource)
			If xmluri.IsFile Then
				'file
				stream = New System.IO.FileStream(xmlsource, System.IO.FileMode.Open)
			Else
				'url
				Dim request As System.Net.HttpWebRequest = CType(System.Net.WebRequest.Create(xmluri), System.Net.HttpWebRequest)
				Dim response As System.Net.WebResponse = request.GetResponse()
				stream = response.GetResponseStream()
			End If
		Catch e As Exception
		End Try 'not a valid uri
    End If
    Return stream
End Function 'GetXmlDoc

Private Sub TranslateButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    If xmlSource Is Nothing Or xmlSource.InnerText = "" Then
		xmlSource.LoadXml(ResultText.Text)
    End If
    Try
		ResultsLiteral.Text = Transform(xmlSource, XslUrlTextBox.Text, Nothing, Nothing)
		ResultsPanel.Visible = True
    Catch transformError As Exception
		ResultsLiteral.Text = transformError.ToString()
    End Try
End Sub

Public Function Transform(ByVal docXml As System.Xml.XmlDocument, ByVal xslUrl As String, ByVal xslParamNames() As String, ByVal xslParamValues() As String) As String
    Dim xslTransform As New System.Xml.Xsl.XslTransform()
    Dim sResult As New System.IO.StringWriter()
    'load xsl to a xsltransform object
    Try
		xslTransform.Load(xslUrl)
    Catch exc As Exception
    End Try

    'load up the xsl parameters, if any
    Dim xslArgs As New System.Xml.Xsl.XsltArgumentList()
    If Not (xslParamNames Is Nothing) Then
		Dim counter As Integer = 0
		Dim paramname As String
		For Each paramname In xslParamNames
			xslArgs.AddParam(paramname, Nothing, xslParamValues(counter))
		Next paramname
    End If

    'try to transform it
    Try
		' call transform
		If Not (xslParamNames Is Nothing) Then
			xslTransform.Transform(docXml, xslArgs, sResult)
		Else
			xslTransform.Transform(docXml, Nothing, sResult)
		End If
    Catch exc As Exception
    End Try
    Return sResult.ToString()
End Function 'Transform 
</script>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" >
<HTML>
	<HEAD>
		<title>Transforming an XML Document Using XSLT</title>
	</HEAD>
	<body>
		<form id="Form1" method="post" runat="server">
		  		Test out the form:<br />
  			1. For the XML Source use:  &quot;http://www.w3schools.com/xsl/cdcatalog.xml&quot;<br />
    		2. Hit the &quot;Load Xml Document&quot; button<br />
    		3. For the XSLT Source use: &quot;http://www.w3schools.com/xsl/cdcatalog.xsl&quot;<br />
    		4. Hit the &quot;Transform&quot; button.<br />
    		5. The result of the Transform will be outputted to the bottom LiteralControl.<br />

			<asp:textbox id="XmlSourceTextBox" runat="server" Width="379px" Height="162px" TextMode="MultiLine"></asp:textbox><BR>
			<asp:button id="LoadButton" runat="server" Text="Load XML Document" OnClick="LoadButton_Click"></asp:button><BR>
			<asp:TextBox id="ResultText" runat="server" Width="379px" Height="194px" TextMode="MultiLine"></asp:TextBox><BR>
			<asp:Button id="TranslateButton" runat="server" Text="Translate" OnClick="TranslateButton_Click"></asp:Button><BR>
			<asp:TextBox id="XslUrlTextBox" runat="server" Height="25px" Width="379"></asp:TextBox><BR>
			<asp:Panel id="ResultsPanel" runat="server" Height="396px" Width="991px" BorderWidth="1px" BorderColor="Red">
				<asp:Literal id="ResultsLiteral" runat="server"></asp:Literal>
			</asp:Panel>
		</form>
	</body>
</HTML>
