<%@ Import Namespace="System" %>
<%@ Import Namespace="System.Xml" %>
<%@ Page Language="C#" %>
<script runat="server">

    //Insert page code here
    
    public void Page_Load(Object Source, EventArgs E)
    {
            XmlTextWriter _Writer = new XmlTextWriter(Server.MapPath("users.xml"), null);
    
            //Default formatting property is None
            _Writer.Formatting = Formatting.Indented;
    
            try{
            
                _Writer.WriteStartDocument(true);
                _Writer.WriteStartElement("users");
                
                WriteUsers(_Writer);
                
                _Writer.WriteEndElement();
                MessageLabel.Text = "File successfully created...";
            }
            catch(Exception _Error){
                MessageLabel.Text = _Error.Message;
            }
            finally{
                _Writer.Flush();
                _Writer.Close();
            }
    
    }
    
    public void WriteUsers(XmlTextWriter _output)
    {
                //First user...
                _output.WriteStartElement("user");
                _output.WriteAttributeString("role", "admin");
                
                _output.WriteStartElement("username");
                _output.WriteString("jsmith");
                _output.WriteEndElement();
                _output.WriteStartElement("password");
                _output.WriteString("john");
                _output.WriteEndElement();
                
                _output.WriteEndElement();
                
                //Second user...
                _output.WriteStartElement("user");
                _output.WriteAttributeString("role", "operator");
                
                _output.WriteStartElement("username");
                _output.WriteString("tcruise");
                _output.WriteEndElement();
                _output.WriteStartElement("password");
                _output.WriteString("tom");
                _output.WriteEndElement();
                
                _output.WriteEndElement();
    }

</script>
<html>
	<head>
		<title>Writing an XML document using the XmlTextWriter</title>
	</head>
	<body>
		<form runat="server">
			<asp:Label id="MessageLabel" runat="server"></asp:Label>
			<hr>
			<a href="users.xml">users.xml</a>
		</form>
	</body>
</html>
