<%@ Page Language="VB" %>
<%@ import Namespace="System.Data" %>
<%@ import Namespace="System.Data.SqlClient" %>
<script runat="server">

    Sub Page_Load(Sender As Object, E As EventArgs)
    
        If Not Page.IsPostBack Then
    
            BindGrid(0)
    
        End If
    
    End Sub
    
	Function GetVirtualItemCount As Integer

		If ViewState("GetVirtualItemCount") Is Nothing Then
		
			Dim ConnectionString As String = "server=(local);database=Northwind;trusted_connection=true"
			Dim CommandText As String = "select count(*) from Products"

			Dim objConnection As New SqlConnection(ConnectionString)
			Dim objCommand As New SqlCommand(CommandText, objConnection)

			Try
				objConnection.Open()
				ViewState("GetVirtualItemCount") = CType(objCommand.ExecuteScalar(), Integer)
		    
			Catch SqlEx As SqlException
				MessageLabel.Text = SqlEx.Message
		    
			Catch Ex As Exception
				MessageLabel.Text = Ex.Message
		    
			Finally
				objConnection.Close()
		    
			End Try

		End If

		Return CInt(ViewState("GetVirtualItemCount"))

	End Function

	Sub myDataGrid_Page(Sender As Object, e As DataGridPageChangedEventArgs)

		myDataGrid.CurrentPageIndex = e.NewPageIndex
		BindGrid(e.NewPageIndex * myDataGrid.PageSize)

	End Sub
    
	Sub BindGrid(StartingIndex As Integer)

		Dim startingID As Integer = StartingIndex
		Dim endingID As Integer = startingID + myDataGrid.PageSize

		Dim ConnectionString As String = "server=(local);database=Northwind;trusted_connection=true"
		Dim CommandText As String = "select ProductID, " & _ 
									"ProductName, " & _ 
									"UnitPrice, " & _ 
									"UnitsInStock " & _ 
									"from Products " & _ 
									"where ProductID > @StartingID and " & _ 
									"ProductID <= @EndingID"

		Dim objConnection As New SqlConnection(ConnectionString)
		Dim objCommand As New SqlDataAdapter(CommandText, objConnection)

		Try
		
			objCommand.SelectCommand.Parameters.Add("@StartingID", startingID)
			objCommand.SelectCommand.Parameters.Add("@EndingID", endingID)

			Dim objDataSet As New DataSet()
			objCommand.Fill(objDataSet)

			myDataGrid.DataSource = objDataSet.Tables(0).DefaultView
			myDataGrid.VirtualItemCount = GetVirtualItemCount()
			myDataGrid.DataBind()
		
		Catch SqlEx As SqlException
			MessageLabel.Text = SqlEx.Message
		
		Catch Ex As Exception
			MessageLabel.Text = Ex.Message
		
		Finally
			objConnection.Close()
		
		End Try

	End Sub

</script>
<html>
	<head>
	</head>
	<body>
		<form runat="server">
			<p>
				<asp:datagrid id="myDataGrid" runat="server" width="100%" OnPageIndexChanged="myDataGrid_Page" PageSize="6" AllowCustomPaging="True" AllowPaging="True">
					<PagerStyle mode="NumericPages" />
				</asp:datagrid>
			</p>
			<p>
				<asp:Label id="MessageLabel" runat="server" ForeColor="Red" Font-Size="Medium" Font-Bold="True" />
			</p>
		</form>
	</body>
</html>
