using System;

namespace AspNetCookbook.Recipe1404cs
{
	public abstract class BankAccount
	{
		private decimal _balance = 0;

		public virtual decimal Balance
		{
			get
			{
				return _balance;
			}
			set
			{
				_balance = value;
			}
		}

		protected virtual void WithdrawFunds(decimal Amount)
		{
			_balance -= Amount;
		}

		protected virtual void DepositFunds(decimal Amount)
		{
			_balance += Amount;
		}
	}

	public class CheckingAccount : BankAccount
	{
		public const decimal CheckFee = 0.25M;
		public void ProcessCheck(decimal Amount)
		{
			WithdrawFunds(Amount + CheckFee);
		}

		public void Deposit(decimal Amount)
		{
			base.DepositFunds(Amount);
		}
	}
}
