Namespace AspNetCookbook.Recipe1404vb
    Public MustInherit Class BankAccount
        Private _balance As Decimal = 0
        Public Property Balance() As Decimal
            Get
                Return _balance
            End Get
            Set(ByVal Value As Decimal)
                _balance = Value
            End Set
        End Property
        Protected Overridable Sub DepositFunds(ByVal Amount As Decimal)
            _balance += Amount
        End Sub
        Protected Overridable Sub WithdrawFunds(ByVal Amount As Decimal)
            _balance -= Amount
        End Sub
    End Class

    Public Class CheckingAccount
        Inherits BankAccount
        Public Const CheckFee As Decimal = 0.25

        Public Sub ProcessCheck(ByVal Amount As Decimal)
            MyBase.WithdrawFunds(Amount + CheckFee)
        End Sub
        Public Sub Deposit(ByVal Amount As Decimal)
            MyBase.DepositFunds(Amount)
        End Sub
    End Class
End Namespace
