using System;

namespace AspNetCookbook
{
	/// <summary>
	/// Demonstration class
	/// 
	/// The public interface of the class will exist of:
	///			- member variable : name
	///			- member function : constructor
	///			- member function : CheckPassword
	/// 
	/// The part of the class hidden for the user and derived classes is:
	///			- member variable : _password
	///			
	///	The part accessible for derived classes:
	///			- member variable : _encryptionKey
	///			- member function : EncryptPassword
	/// 
	/// </summary>
	public class MyClass
	{
		// Public member variable : can be accessed when an intance of this class has been created
		public string name;

		// Private member: only accessible inside this class
		private string _password;

		// Protected member: this can be accessed from within this class and from all derived classes
		protected string _encryptionKey;	// This and derived classes should know how to decrypt the password !

		// public class constructor
		public MyClass()
		{
		}

		// Protected member function : this happens internally without the user of the class knows it
		protected string EncryptPassword(string password)
		{
			// do something
			return password;
		}

		// Public password validation routine.  The password is private, but this routine allows password validation
		public bool CheckPassword(string str)
		{
			if (EncryptPassword(str) == _password) return true;
			else return false;
		}

		
	}
}
