<%@ Page language="VB" %>
<%@ Import Namespace="System.CodeDom" %>
<%@ Import Namespace="System.CodeDom.Compiler" %>
<%@ Import Namespace="System.Reflection" %>
<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="Microsoft.CSharp" %>
<%@ Import Namespace="Microsoft.VisualBasic" %>
<html>
	<head>
		<script language="VB" runat="server">
    Public Function CreateVbCode(ByVal filepath As String) As String
      Dim sw As StreamWriter = Nothing 
      Try
        sw = File.CreateText(filepath)

        Dim codeProvider As VBCodeProvider = New VBCodeProvider()
        Dim codeGenerator As ICodeGenerator = codeProvider.CreateGenerator(sw) 
        Dim options As CodeGeneratorOptions = New CodeGeneratorOptions() 
 
        'Create namespace references
        Dim usingSnippet1 As CodeSnippetCompileUnit = New CodeSnippetCompileUnit("Imports System") 
        codeGenerator.GenerateCodeFromCompileUnit(usingSnippet1, sw, options)
        sw.WriteLine()
 
        'Create namespace
        Dim recipesNamespace As CodeNamespace = New CodeNamespace("Recipes") 
 
        'Create RoundMeasures Class Declaration
        Dim roundMeasures As CodeTypeDeclaration = New CodeTypeDeclaration() 
        roundMeasures.IsClass = True
        roundMeasures.Name = "RoundMeasures"
        roundMeasures.TypeAttributes = TypeAttributes.Public
 
        'Create Round Class Declaration
        Dim round As CodeTypeDeclaration = New CodeTypeDeclaration() 
        Dim roundComment As CodeComment = New CodeComment() 
        roundComment.Text = "Round calculates the Area of a Circle, the Area of a Sphere, and the Volume of a Sphere"
        Dim roundCommentStatement As CodeCommentStatement = New CodeCommentStatement(roundComment) 
        round.Comments.Add(roundCommentStatement)
        round.IsClass = True
        round.Name = "Round"
        round.TypeAttributes = TypeAttributes.Public
 
        'Create Class Member Field m_radius
        Dim radiusMember As CodeMemberField = New CodeMemberField(type.GetType("System.Double"),"m_radius") 
        radiusMember.Attributes = MemberAttributes.Private
        radiusMember.Comments.Add(New CodeCommentStatement("The radius used to calculate areas and volume."))
        round.Members.Add(radiusMember)
 
        'Create Round Class Constructor
        Dim roundConstructor As CodeConstructor = New CodeConstructor() 
        roundConstructor.Attributes = MemberAttributes.Public
        Dim roundConParameter As CodeParameterDeclarationExpression = _
          New CodeParameterDeclarationExpression(type.GetType("System.Double"),"pRadius") 
        roundConstructor.Parameters.Add(roundConParameter)
        roundConstructor.Statements.Add(New CodeSnippetStatement("Me.m_radius = pRadius"))
        round.Members.Add(roundConstructor)
 
        'Create Radius Property
        Dim radiusProperty As CodeMemberProperty = New CodeMemberProperty() 
        radiusProperty.Attributes = MemberAttributes.Public
        radiusProperty.Type = New CodeTypeReference(type.GetType("System.Double"))
        radiusProperty.Name = "Radius"
        radiusProperty.HasGet = True
        radiusProperty.GetStatements.Add(New CodeSnippetExpression("Return m_radius"))
        radiusProperty.HasSet = True
        radiusProperty.SetStatements.Add(New CodeSnippetExpression("m_radius = value"))
        round.Members.Add(radiusProperty)
 
        'Create CircleArea Method
        Dim circleAreaMethod As CodeMemberMethod = New CodeMemberMethod() 
        circleAreaMethod.Comments.Add(New CodeCommentStatement("Calculates the area of a circle."))
        circleAreaMethod.Name = "CircleArea"
        circleAreaMethod.ReturnType = New CodeTypeReference(type.GetType("System.Double"))
        circleAreaMethod.Attributes = MemberAttributes.Public
        circleAreaMethod.Statements.Add(New CodeSnippetStatement("Return Math.PI * m_radius * m_radius"))
        round.Members.Add(circleAreaMethod)
 
        'Create SphereArea Method
        Dim sphereAreaMethod As CodeMemberMethod = New CodeMemberMethod() 
        sphereAreaMethod.Comments.Add(New CodeCommentStatement("Calculates the area of a sphere."))
        sphereAreaMethod.Name = "SphereArea"
        sphereAreaMethod.ReturnType = New CodeTypeReference(type.GetType("System.Double"))
        sphereAreaMethod.Attributes = MemberAttributes.Public
        sphereAreaMethod.Statements.Add(New CodeSnippetStatement("Return 4 * CircleArea()"))
        round.Members.Add(sphereAreaMethod)
 
        'Create SphereVolume Method
        Dim sphereVolumeMethod As CodeMemberMethod = New CodeMemberMethod() 
        sphereVolumeMethod.Comments.Add(New CodeCommentStatement("Calculates the volume of a sphere."))
        sphereVolumeMethod.Name = "SphereVolume"
        sphereVolumeMethod.ReturnType = New CodeTypeReference(type.GetType("System.Double"))
        sphereVolumeMethod.Attributes = MemberAttributes.Public
        sphereVolumeMethod.Statements.Add(New CodeSnippetStatement("Return SphereArea() * m_radius / 3"))
        round.Members.Add(sphereVolumeMethod)
 
        'Add Round class to RoundMeasures class
        roundMeasures.Members.Add(round)
 
        'Create Main Method
        Dim mainMethod As CodeMemberMethod = New CodeMemberMethod() 
        mainMethod.Name = "Main"
        mainMethod.Attributes = MemberAttributes.Public
        mainMethod.Attributes = MemberAttributes.Static
        mainMethod.Statements.Add(New CodeSnippetStatement("Dim r As Double = 5.0"))
        mainMethod.Statements.Add(New CodeSnippetStatement("Dim rnd As Round = New Round(r)"))
        mainMethod.Statements.Add(New CodeSnippetStatement("Console.WriteLine(""Radius of Circle: {0:f1}"", rnd.Radius)"))
        mainMethod.Statements.Add(New CodeSnippetStatement("Console.WriteLine(""Area of Circle: {0:f1}"", rnd.CircleArea())"))
        mainMethod.Statements.Add(New CodeSnippetStatement("Console.WriteLine(""Area of Sphere: {0:f1}"", rnd.SphereArea())"))
        mainMethod.Statements.Add(New CodeSnippetStatement("Console.WriteLine(""Volume of Sphere: {0:f1}"", rnd.SphereVolume())"))
        roundMeasures.Members.Add(mainMethod)
 
        'Add RoundMeasures class to Recipe namespace
        recipesNamespace.Types.Add(roundMeasures)
 
        'Generate Source Code File
        codeGenerator.GenerateCodeFromNamespace(recipesNamespace, sw, options)
 
        Return filepath & " was successfully created."
      Catch ex As Exception
        Return "Error: " & ex.Message
      Finally
        'Close StreamWriter
        If Not sw Is Nothing Then
           sw.Close()
        End If
      End Try
    End Function
 
    Private Sub btnGenerate_Click(ByVal sender As Object, ByVal e As System.EventArgs)
      Result.Text = CreateVbCode(Server.MapPath("Round.vb.txt"))
      link.Text = "View Code"
      link.NavigateUrl = "Round.vb.txt"
    End Sub
		</script>
		<title>Generating a Class Using the CodeDOM</title>
	</head>
	<body>
		<form id="CreateCode" method="post" runat="server">
			<asp:Button id="btnGenerate" runat="server" Text="Create Code" OnClick="btnGenerate_Click"></asp:Button><br>
			<br>
			<asp:Label id="Result" runat="server"></asp:Label>
			<asp:HyperLink ID="link" Runat="server"/>
		</form>
	</body>
</html>
