<%@ Page language="VB" %>
<%@ Import Namespace="System.CodeDom" %>
<%@ Import Namespace="System.CodeDom.Compiler" %>
<%@ Import Namespace="System.Reflection" %>
<%@ Import Namespace="System.IO" %>
<%@ Import Namespace="System.Text" %>
<%@ Import Namespace="Microsoft.CSharp" %>
<%@ Import Namespace="Microsoft.VisualBasic" %>
<html>
 <head>
  <script language="VB" runat="server">
    Public Function CreateVbCode() As String
       Try
          'Language specific code provider
          Dim codeProvider As VBCodeProvider = New VBCodeProvider()

          'Create Code Compile Unit
          Dim compileUnit As New CodeCompileUnit()

          'Create namespace
          Dim recipesNamespace As New CodeNamespace("Recipes")

          'Create namespace references
          recipesNamespace.Imports.Add(New CodeNamespaceImport("System"))

          'Create Round Class Declaration
          Dim round As CodeTypeDeclaration = New CodeTypeDeclaration() 
          Dim roundComment As CodeComment = New CodeComment() 
          roundComment.Text = "Round calculates the Area of a Circle, the Area of a Sphere, and the Volume of a Sphere"
          Dim roundCommentStatement As CodeCommentStatement = New CodeCommentStatement(roundComment) 
          round.Comments.Add(roundCommentStatement)
          round.IsClass = True
          round.Name = "Round"
          round.TypeAttributes = TypeAttributes.Public

          'Create Class Member Field m_radius
          Dim radiusMember As CodeMemberField = New CodeMemberField(type.GetType("System.Double"),"m_radius") 
          radiusMember.Attributes = MemberAttributes.Private
          radiusMember.Comments.Add(New CodeCommentStatement("The radius used to calculate areas and volume."))
          round.Members.Add(radiusMember)

          'Create Round Class Constructor
          Dim roundConstructor As CodeConstructor = New CodeConstructor() 
          roundConstructor.Attributes = MemberAttributes.Public
          Dim roundConParameter As CodeParameterDeclarationExpression = _
            New CodeParameterDeclarationExpression(type.GetType("System.Double"),"pRadius") 
          roundConstructor.Parameters.Add(roundConParameter)
          roundConstructor.Statements.Add(New CodeSnippetStatement("Me.m_radius = pRadius"))
          round.Members.Add(roundConstructor)

          'Create Radius Property
          Dim radiusProperty As CodeMemberProperty = New CodeMemberProperty() 
          radiusProperty.Attributes = MemberAttributes.Public
          radiusProperty.Type = New CodeTypeReference(type.GetType("System.Double"))
          radiusProperty.Name = "Radius"
          radiusProperty.HasGet = True
          radiusProperty.GetStatements.Add(New CodeSnippetExpression("Return m_radius"))
          radiusProperty.HasSet = True
          radiusProperty.SetStatements.Add(New CodeSnippetExpression("m_radius = value"))
          round.Members.Add(radiusProperty)

          'Create CircleArea Method
          Dim circleAreaMethod As CodeMemberMethod = New CodeMemberMethod() 
          circleAreaMethod.Comments.Add(New CodeCommentStatement("Calculates the area of a circle."))
          circleAreaMethod.Name = "CircleArea"
          circleAreaMethod.ReturnType = New CodeTypeReference(type.GetType("System.Double"))
          circleAreaMethod.Attributes = MemberAttributes.Public
          circleAreaMethod.Statements.Add(New CodeSnippetStatement("Return Math.PI * m_radius * m_radius"))
          round.Members.Add(circleAreaMethod)

          'Create SphereArea Method
          Dim sphereAreaMethod As CodeMemberMethod = New CodeMemberMethod() 
          sphereAreaMethod.Comments.Add(New CodeCommentStatement("Calculates the area of a sphere."))
          sphereAreaMethod.Name = "SphereArea"
          sphereAreaMethod.ReturnType = New CodeTypeReference(type.GetType("System.Double"))
          sphereAreaMethod.Attributes = MemberAttributes.Public
          sphereAreaMethod.Statements.Add(New CodeSnippetStatement("Return 4 * CircleArea()"))
          round.Members.Add(sphereAreaMethod)

          'Create SphereVolume Method
          Dim sphereVolumeMethod As CodeMemberMethod = New CodeMemberMethod() 
          sphereVolumeMethod.Comments.Add(New CodeCommentStatement("Calculates the volume of a sphere."))
          sphereVolumeMethod.Name = "SphereVolume"
          sphereVolumeMethod.ReturnType = New CodeTypeReference(type.GetType("System.Double"))
          sphereVolumeMethod.Attributes = MemberAttributes.Public
          sphereVolumeMethod.Statements.Add(New CodeSnippetStatement("Return SphereArea() * m_radius / 3"))
          round.Members.Add(sphereVolumeMethod)

          'Add Round class to Recipe namespace
          recipesNamespace.Types.Add(round)

          'Add Namespace to Code Compile Unit
          compileUnit.Namespaces.Add(recipesNamespace)

          'Create ICodeCompiler
          Dim compiler As ICodeCompiler = codeProvider.CreateCompiler()

          'input parameters for the compiler
          Dim compilerParams As New CompilerParameters()
          Dim filepath As String = Path.GetDirectoryName(Request.PhysicalPath)
          compilerParams.OutputAssembly = filepath + "\Round.dll"
          compilerParams.ReferencedAssemblies.Add("System.dll")
          compilerParams.GenerateExecutable = False 'dll not exe
          'Compile the assembly using the Compile Unit
          Dim results As CompilerResults = compiler.CompileAssemblyFromDom(compilerParams, compileUnit)

          Dim sb As New StringBuilder()
          Dim compError As CompilerError
          For Each compError In  results.Errors
             sb.Append(compError.ErrorText)
             sb.Append("<br>")
          Next compError

          Dim output As String
          For Each output In  results.Output
             sb.Append(output)
             sb.Append("<br>")
          Next output

          Return "Round Class compiled. " + sb.ToString()
       Catch ex As Exception
          Return "Error: " + ex.Message
       End Try
    End Function


    Private Sub btnGenerate_Click(sender As Object, e As System.EventArgs)
       Result.Text = CreateVbCode()
    End Sub
  </script>
  <title>Compiling a Class Using the CodeDOM</title>
  </head>
  <body>
    <form id="CreateCode" method="post" runat="server">
      <asp:Button id="btnGenerate" runat="server" Text="Create Code" OnClick="btnGenerate_Click"></asp:Button><br>
      <br>
      <asp:Label id="Result" runat="server"></asp:Label>
    </form>
  </body>
</html>
